
# Codes for “Regularisation, optimisation, subregularity”

Author: Tuomo Valkonen <tuomov@iki.fi>

This repository contains the codes for the numerical demonstrations in
“Regularisation, optimisation, subregularity” (https://arxiv.org/abs/2011.07575).

## Prerequisites

These codes were written for Julia 1.5.2. The  package dependencies are from January 2021 when our experiments were run. You may get Julia from [julialang.org](https://julialang.org/).

## Using

Navigate your unix shell to the directory containing this `README.md` and then run:

```sh
    $ julia --project=.
```

The first time doing this, to ensure all the dependencies are installed, run

```julia
    julia> ]instantiate
```

Afterwards in the Julia shell, type:

```julia
    julia> using Regtheory
```

This may take a while as Julia precompiles the code. Then, to generate all the experiments in the manuscript, run:

```julia
    julia> batchrun()
```

This will write the data in the manusript to `tv-results.txt`, and the images to several files of the form `data_*.png`, `reco_*.png`, and `error_*.png`.
To alter the computations performed, see `src/TV.jl`.
In particular, the array `experiments_tv` lists the different the parameters $α$, $δ$, and $N$ while `default_params` contains the parameters of the algorithm.
